// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2020 Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using System;
using System.Globalization;

namespace Hiperscan.GtkExtensions.Widgets
{
    public class OutLinedValidatedMonthCombobox : OutLinedValidatedCombobox
    {
        public OutLinedValidatedMonthCombobox(Gtk.ComboBox combobox, CultureInfo culture) : base(combobox)
        {
            if (this.GtkCombobox.Model == null)
            {
                Gtk.ListStore store = new Gtk.ListStore(typeof(string));
                Gtk.CellRendererText text = new Gtk.CellRendererText();
                this.GtkCombobox.Clear();
                this.GtkCombobox.PackStart(text, false);
                this.GtkCombobox.SetAttributes(text, "text", 0);
                this.GtkCombobox.Model = store;
            }

            ((Gtk.ListStore)this.GtkCombobox.Model).Clear();
            this.GtkCombobox.AppendText("-");
            DateTime date = DateTime.MinValue;
            for (int i = 0; i < 12; i++)
                this.GtkCombobox.AppendText(date.AddMonths(i).ToString("MMMM", culture));

            this.GtkCombobox.Active = 0;

            this.GtkCombobox.Changed += (o, args) =>
            {
                this.Refresh();
                this.CallValueChangedEvent();
            };

            this.Refresh();
        }

        public bool SetMonth(int month)
        {
            if (month < 1)
                return false;

            if (month > 12)
                return false;

            this.GtkCombobox.Active = month;
            this.Refresh();
            return true;
        }

        protected override bool Check()
        {
            return this.GtkCombobox.Active > 0;
        }
    }
}
